﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Alg12SortWstawianie
{
    public partial class Form1 : Form
    {
        Int32[] tab;
        int rozmiar;
        void losujTablice(Int32[] t, int zakres)
        {
            Random r = new Random();
            int i = 0;
            //mogą występować powtórzenia wylosowanych elementów
            while (i < t.Length)
            {
                t[i] = r.Next(zakres) + 1;
                i++;
            }
        }
        void sortPrzezWstawianie(Int32[] t, int rozmiar)
        {
            Int32[] tabBufor=new Int32[rozmiar];//tablica pomocnicza
            int licznik = 0;//licznik posortowanych elementów
            //szukaj w petli indeksu wstawienia bieżącego elementu
            for(int i = 0; i < rozmiar; i++)
            {
                Int32 aktualny = t[i];
                //indeks w tablicy bufor, określany na podst. licznika
                //juz psortowanych elementów
                int idBufor =licznik;
                for(int j = 0; j < licznik; j++)
                    //sprawdz czy biezacy jest wiekszy od aktualnego
                    if (tabBufor[j]>aktualny)
                    {
                       //jak tak, to zapamietaj pozycję biezącego
                       idBufor = j;
                       //wyskocz, bo okresliłeś pozycję do wstawiania
                       break;
                    }
                //przesun elemty w tab. bufor
                //od końca
                for (int k = licznik; k > idBufor; k--)
                    tabBufor[k] = tabBufor[k - 1];
                //podmień elemet na posortowany
                tabBufor[idBufor]=aktualny;
                //zwieksz licznik posortowanych elementów
                licznik++;
            }
            //przekopiuj elementy z tablicy bufora do tablicy źródła
            //i to już będzie tablica posortowana
            for(int i=0;i<rozmiar; i++)
                t[i]= tabBufor[i];
        }
        void sortPrzezWstawianieLiniowe(Int32[] t, int rozmiar)
        {
            int bufor, j;
            for(int i = 1; i < rozmiar; i++)
            {
                bufor = t[i];
                j = i - 1;
                while(j>=0 && t[j] > bufor)
                {
                    t[j + 1] = t[j];//przesun elemety;
                    j--;//zmniejsz licznik pozycji do przeglądnięcia
                }
                t[j + 1] = bufor;//wstaw element 
            }
        }
        public Form1()
        {
            InitializeComponent();
        }

        private void textBox2_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 8) return;//wyskocz jak BackSpace
            if (e.KeyChar < '0' || e.KeyChar > '9') e.Handled = true;//ignoru nienumeryczne
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //losowanie nowej tablicy
            if (textBox2.Text.Length < 1) return;
            //wyczysc stara tablice
            if (tab != null) Array.Clear(tab, 0, tab.Length);
            //ustaw nowy rozmiar
            rozmiar = int.Parse(textBox2.Text);
            tab = new int[rozmiar];
            //przy losowaniu ustaw zakres na 2 razy większy od rozmiaru
            losujTablice(tab, 2 * rozmiar);
            //pokaz wylosowany zbior
            textBox1.Clear();
            for (int i = 0; i < tab.Length; i++)
                textBox1.AppendText(tab[i].ToString() + Environment.NewLine);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (tab == null) return;
            sortPrzezWstawianie(tab, rozmiar);
            //wypisz posortowaną
            //pokaz wylosowany zbior
            textBox3.Clear();
            for (int i = 0; i < tab.Length; i++)
                textBox3.AppendText(tab[i].ToString() + Environment.NewLine);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (tab == null) return;
            sortPrzezWstawianieLiniowe(tab, rozmiar);
            //wypisz posortowaną
            //pokaz wylosowany zbior
            textBox3.Clear();
            for (int i = 0; i < tab.Length; i++)
                textBox3.AppendText(tab[i].ToString() + Environment.NewLine);
        }
    }
}
